// Code generated by goa v3.12.3, DO NOT EDIT.
//
// login endpoints
//
// Command:
// $ goa gen gitlab.eclipse.org/eclipse/xfsc/tsa/login/design

package login

import (
	"context"

	goa "goa.design/goa/v3/pkg"
)

// Endpoints wraps the "login" service endpoints.
type Endpoints struct {
	Login           goa.Endpoint
	LoginInvitation goa.Endpoint
	LoginWithVC     goa.Endpoint
	Keys            goa.Endpoint
}

// NewEndpoints wraps the methods of the "login" service with endpoints.
func NewEndpoints(s Service) *Endpoints {
	return &Endpoints{
		Login:           NewLoginEndpoint(s),
		LoginInvitation: NewLoginInvitationEndpoint(s),
		LoginWithVC:     NewLoginWithVCEndpoint(s),
		Keys:            NewKeysEndpoint(s),
	}
}

// Use applies the given middleware to all the "login" service endpoints.
func (e *Endpoints) Use(m func(goa.Endpoint) goa.Endpoint) {
	e.Login = m(e.Login)
	e.LoginInvitation = m(e.LoginInvitation)
	e.LoginWithVC = m(e.LoginWithVC)
	e.Keys = m(e.Keys)
}

// NewLoginEndpoint returns an endpoint function that calls the method "Login"
// of service "login".
func NewLoginEndpoint(s Service) goa.Endpoint {
	return func(ctx context.Context, req any) (any, error) {
		p := req.(*LoginRequest)
		return s.Login(ctx, p)
	}
}

// NewLoginInvitationEndpoint returns an endpoint function that calls the
// method "LoginInvitation" of service "login".
func NewLoginInvitationEndpoint(s Service) goa.Endpoint {
	return func(ctx context.Context, req any) (any, error) {
		return s.LoginInvitation(ctx)
	}
}

// NewLoginWithVCEndpoint returns an endpoint function that calls the method
// "LoginWithVC" of service "login".
func NewLoginWithVCEndpoint(s Service) goa.Endpoint {
	return func(ctx context.Context, req any) (any, error) {
		p := req.(*LoginVCRequest)
		return s.LoginWithVC(ctx, p)
	}
}

// NewKeysEndpoint returns an endpoint function that calls the method "Keys" of
// service "login".
func NewKeysEndpoint(s Service) goa.Endpoint {
	return func(ctx context.Context, req any) (any, error) {
		return s.Keys(ctx)
	}
}
